// NoPro - webwork 2013

/*
 * some handy debug-functions for js/jquery
 */

var crlf = "\r\n";
function scrolldown(jso) { jso.scrollTop = jso.scrollHeight; }

function dump_obj(o,here) { // debug-fn
    var info = "";
    $.each(o, function (k, v) { info += 'k=' +k+ ', v=' +v+ "\n"; });
    if(here)
	dbg(info, true);
    else
	alert(info);
}

function dbg(msg, app, cont) {
    var text = cont ? '<div class="'+ cont +'">' : '<pre>';
    if(app) {
	$('.dbginfo').append(text + msg.replace(/</g,'&lt;'));
	scrolldown($('.dbginfo')[0]);	
    } else
	$('.dbginfo').html(text + msg);
}

$(document).ready(function() {
    // view dbgbox
    $('body').append('<div id="dbgbox" class="box round9px fix"></div>');
    $('#dbgbox')
	.css({'width': "50%", 'max-height': '80%', 'min-height': '100px', 'background':'white', 'padding': "0 0 14px 6px", 'z-index': 2})
	.append('<div class="wintop round">debug-info</div>')
	.append('<div class="dbginfo ascroll rel"></div>')
	.append('<div class="xit round clix" title="clear">O</div>')
	.delegate('.xit, .xit *', 'click', function(e) { dbg(''); return false; })
    ;
    if(is_mobile()) {
	$('#dbgbox .xit').css({'font-size': '32px'});
	$('#dbgbox')
	    .delegate('.xit, .xit *', 'touchstart', function(e) { dbg(''); return false; })
	    .delegate('.wintop, .dbginfo', 'touchstart', function(eve) {
		follow = document.getElementById('dbgbox');
		if(!follow) {
		    dbg(eve.type+ ' id not found');
		    return true;
		}
		eve.preventDefault();
		var touch = eve.originalEvent.touches[0] || eve.originalEvent.changedTouches[0];
		x0 = touch.clientX;
		y0 = touch.clientY;
		// ensure that positioning css-vals are set
		if(!follow.style.left) { follow.style.left = follow.offsetLeft +"px"; }
		if(!follow.style.top)  { follow.style.top  = follow.offsetTop  +"px"; }
		fx1 = parseInt(follow.style.left);
		fy1 = parseInt(follow.style.top);
		$(document)
		    .bind('touchmove', function(e) { return dragit(e); })
		    .bind('touchend touchcancel', function(e) {
			$(document).off('touchmove touchend touchcancel');
			follow = null;
			return false;
		    })
		;
		return false;
	    });
    } else {
	$('#dbgbox')
	    .delegate('.wintop', 'mousedown', function(e) { drag(this.parentNode, e, true); return false; });
    }
    var tmp = $(window).width() - $('#dbgbox').outerWidth(true) -8;
    $('#dbgbox').css({'top': '8px', 'left': tmp+'px'});
    //tmp = $('#dbgbox').css('max-height');		// works with firefox only
    tmp = parseInt($(window).height() * .8) + 'px';
    $('.dbginfo').css({'max-height': tmp, 'min-height': '100px', 'top': '14px'});
});

function jq_clean(jqs) {
    // 
    $(jqs).clearQueue();
    $(jqs).stop();
    $(jqs).unbind();
    //$(jqs).off();
}

function recuview(o) {
    // recursive view object
    // return string

    if(typeof(o) != 'object') {
	dbg("recuview(): "+ typeof(o) +': '+o, true);
	return;
    }
    
    var dst = crlf+ '<dl>';
    $.each(o, function(k,v) {
	if(typeof(v) == 'object') {
	    dst += crlf+ '<dt>'+ k +': {</dt>';
	    dst += crlf+ '<dd>';
	    dst += recuview(o[k]);
	    dst += crlf+ '</dd><dt>}</dt>';
	} else
	    dst += crlf+ '<dt>'+ k +': '+ v +'</dt>';
    });
    dst += crlf+ '</dl>';
    return dst;
}
